/*******************************************************************************
*  skI2Cmaster - hQbʐMs}X^[p̊֐Cu                    *
*                                                                              *
*    InterI2C       - hQb֘Å荞ݏ                                 *
*    InitI2C_Master - hQbʐM̃}X^[[hŏs             *
*    I2C_Send      - X[uɃf[^w肵M鏈            *
*    I2C_Receive   - X[uf[^w肵M鏈          *
*                                                                              *
*    FSDA/SCLs͕KufW^̓svɐݒsĉB         *
*          I2C֐Cu͂VrbgAhX[ĥݑΉłB         *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2011-12-23  ޒH[(ނ)  Create                            *
*  2.00    2012-01-21  ޒH[(ނ)  X[uACK҂ύX   *
*  3.00    2017-12-20  ޒH[(ނ)  NOACKs̃oOύX         *
* ============================================================================ *
*  PIC 12F1822 16F1827                                                         *
*  MPLAB IDE(V8.63)                                                            *
*  HI-TECH C Compiler for PIC10/12/16 MCUs Version 9.80 in Lite mode           *
*******************************************************************************/
#include <pic.h>

int AckCheck ;

// AChԂ̃`FbN
// ACKEN RCEN PEN RSEN SEN R/W BF SĂOȂnj
void I2C_IdleCheck(char mask)
{
     while (( SSP1CON2 & 0x1F ) | (SSP1STAT & mask)) ;
}
/*******************************************************************************
*  interrupt InterI2C( void )                                                  *
*    hQb֘Å荞ݏ                                                  *
*******************************************************************************/
void interrupt InterI2C( void )
{
     if (SSP1IF == 1) {       // SSP(I2C)荞ݔH
	     if (AckCheck == 1) AckCheck = 0 ;
          SSP1IF = 0 ;        // tONA
     }
     if (BCL1IF == 1) {       // MSSP(I2C)oXՓˊ荞ݔH
          BCL1IF = 0 ;        // ̓tÔ݃NA()
     }
}
/*******************************************************************************
*  InitI2C_Master()                                                            *
*    hQbʐM̃}X^[[hŏs                              *
*                                                                              *
*   )CPUۯ(FOSC)8MHzł̐ݒłA̸ۯSSP1ADDύXKvL܂*
*******************************************************************************/
void InitI2C_Master()
{
     SSP1STAT= 0b10000000 ;   // Wx[hɐݒ肷(100kHz)
     SSP1CON1= 0b00101000 ;   // SDA/SCLsI2CŎgpA}X^[[hƂ
     SSP1ADD = 0x13       ;   // NbN=FOSC/((SSPADD + 1)*4) 8MHz/((0x13+1)*4)=0.1(100KHz)
     SSP1IE = 1 ;             // SSP(I2C)荞݂
     BCL1IE = 1 ;             // MSSP(I2C)oXՓˊ荞݂
     PEIE   = 1 ;             // ӑu荞݂
     GIE    = 1 ;             // S荞ݏ 
     SSP1IF = 0 ;             // SSP(I2C)荞݃tONA
     BCL1IF = 0 ;             // MSSP(I2C)oXՓˊ荞݃tONA
}
/*******************************************************************************
*  ans = I2C_Send(adrs,len,buf)                                                *
*    X[uɃf[^w肵(len)M鏈                       *
*                                                                              *
*    adrs : X[ũAhXw肷(8`119𐄏)                         *
*    len  : Mf[^(oCg)̌w肷                             *
*    buf  : Mf[^i[zw肷                             *
*    ans  : 0=@1=X[uԓȂ@2=肪f[^̎Mۂ     *
*******************************************************************************/
int I2C_Send(unsigned char adrs,int len,char *buf)
{
     int i , ans ;

     // X^[g(START CONDITION)
     I2C_IdleCheck(0x5) ;
     SSP1CON2bits.SEN = 1 ;
     // [X[ũAhX+X[u͎Mv]𑗐M
     I2C_IdleCheck(0x5) ;
     AckCheck = 1 ;
     SSP1BUF = (char)(adrs<<1) ;             // AhX𑗐M R/W=0
     while (AckCheck) ;                      // 肩ACKԓ҂
     ans = SSP1CON2bits.ACKSTAT ;
     if (ans == 0) {
          // [f[^]𑗐M
          for (i=0 ; i<len ; i++) {
               I2C_IdleCheck(0x5) ;
               AckCheck = 1 ;
               SSP1BUF = (char)*buf ;        // f[^𑗐M
               buf++ ;
               while (AckCheck) ;            // 肩ACKԓ҂
               ans = SSP1CON2bits.ACKSTAT ;
               if (ans != 0) {
                    ans = 2 ;                // 肪NOACKԂ
                    break ;
               }
          }
     }
     // Xgbv(STOP CONDITION)
     I2C_IdleCheck(0x5) ;
     SSP1CON2bits.PEN = 1 ;
     return ans ;
}
/*******************************************************************************
*  ans = I2C_Receive(adrs,len,buf)                                             *
*    X[uf[^w肵(len)M鏈                     *
*                                                                              *
*    adrs : X[ũAhXw肷(8`119𐄏)                         *
*    len  : Mf[^(oCg)̌w肷                             *
*    buf  : Mf[^i[zw肷                             *
*    ans  : 0=@1=X[uԓȂ                                     *
*******************************************************************************/
int I2C_Receive(unsigned char adrs,int len,char *buf)
{
	unsigned dt ;
     int i , ans ;
     
     // X^[g(START CONDITION)
     I2C_IdleCheck(0x5) ;
     SSP1CON2bits.SEN = 1 ;
     // [X[ũAhX+X[uփf[^v]𑗐M
     I2C_IdleCheck(0x5) ;
     AckCheck = 1 ;
     SSP1BUF = (char)((adrs<<1)+1) ;    // AhX𑗐M R/W=1
     while (AckCheck) ;                 // 肩ACKԓ҂
     ans = SSP1CON2bits.ACKSTAT ;
     if (ans == 0) {
          for (i=1 ; i<=len ; i++) {
               // [f[^]M
               I2C_IdleCheck(0x5) ;
               SSP1CON2bits.RCEN = 1 ;  // M
               I2C_IdleCheck(0x4) ;
               *buf = SSP1BUF ;         // M
               buf++ ;
               I2C_IdleCheck(0x5) ;
               if (i==len) SSP1CON2bits.ACKDT = 1 ; // ACKf[^NOACK
               else        SSP1CON2bits.ACKDT = 0 ; // ACKf[^ACK
               SSP1CON2bits.ACKEN = 1 ;             // ACKf[^Ԃ
          }
     }
     // Xgbv(STOP CONDITION)
     I2C_IdleCheck(0x5) ;
     SSP1CON2bits.PEN = 1 ;
     return ans ;
}
